#define snapshot	20080501
%define snapshot 0
%define	rel		4

%if %snapshot
%define release	%mkrel 0.%snapshot.%rel
%else
%define	release	%mkrel %rel
%endif

%define	major		0
%define libname 	%mklibname %{name} %{major}
%define develname	%mklibname %{name} -d

Summary:	Linux Infrared Remote Control daemons
Name:		lirc
Version:	0.8.3
Release:	%{release}
License:	GPLv2+
Group:		System/Kernel and hardware
%if %snapshot
# cvs -d:pserver:anonymous@lirc.cvs.sourceforge.net:/cvsroot/lirc login
# cvs -z8 -d:pserver:anonymous@lirc.cvs.sourceforge.net:/cvsroot/lirc co lirc
Source0:	%{name}-%{snapshot}.tar.lzma
%else
Source0:	http://prdownloads.sourceforge.net/lirc/%{name}-%{version}.tar.bz2
%endif
Source2:	lircd.sysconfig
Source3:	lircd.init
Source4:	lircmd.init
# (fc) 0.8.3-1mdv add include directive support for config file (Fedora)
Patch0:		lirc-0.8.3-remote-includes-directive.patch
# (fc) 0.8.3-1mdv validate transmit buffer (upstream)
Patch1:		lirc-0.8.3-validate-transmit-buffer.patch
# (fc) 0.8.3-1mdv use new instead of conf as filename suffix in template mode (Fedora)
Patch2:		lirc-use-new-instead-of-conf-as-filename-suffix.patch
# (fc) 0.8.3-2mdv don't exit daemon even though device cannot be initialized (CVS)
Patch3:		lirc-0.8.3-dontexit.patch
# (pt) 0.8.3-3mdv patches from cvs to build on 2.6.27
Patch4:		lirc-0.8.3-2.6.27.patch
URL:		http://www.lirc.org/
BuildRequires:	autoconf
BuildRequires:	X11-devel
BuildRequires:  libirman-static-devel
BuildRequires:	libusb-devel
%if %mdkversion >= 200710
BuildRequires:	portaudio0-devel
%else
BuildRequires:	portaudio-devel
%endif
BuildRequires:	libalsa-devel
BuildRequires:	help2man
Requires(post):	rpm-helper
Requires(preun):rpm-helper
Requires:	setserial
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
LIRC is a package that allows you to decode and send infra-red signals
of many (but not all) commonly used remote controls.

Configuration files for many remotes are locate in lirc-remotes package

%package -n	%{libname}
Summary:	LIRC libraries
Group:		System/Libraries

%description -n	%{libname}
This package provides the libraries necessary to run lirc client
programs.

%package -n	%{develname}
Summary:	Header and library files for LIRC development
Group:		Development/Other
Requires:	%{libname} = %{version}-%{release}
Provides:	lib%{name}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Obsoletes:	%{mklibname lirc 0 -d}

%description -n	%{develname}
This package provides the files necessary to develop LIRC-based
programs.

%package -n	dkms-%{name}
Summary:	Kernel modules for LIRC
Group:		System/Kernel and hardware
Requires(post):	dkms
Requires(preun): dkms

%description -n	dkms-%{name}
This package provides the kernel modules for LIRC.

Install this package if the LIRC driver you are using requires
them and your kernel doesn't include them.

Note that lirc_gpio and lirc_parallel are in packages of their own.

%package -n     dkms-%{name}-parallel
Summary:        Parallel port module for LIRC
Group:          System/Kernel and hardware
Requires:       dkms-%{name} = %version
Requires(post): dkms
Requires(preun): dkms

%description -n dkms-%{name}-parallel
This package provides the parallel port module for LIRC.

This module requires a non-SMP kernel.

%package -n	dkms-%{name}-gpio
Summary:	GPIO module for LIRC
Group:		System/Kernel and hardware
Requires:	dkms-%{name} = %version
Requires(post):	dkms
Requires(preun): dkms

%description -n	dkms-%{name}-gpio
This package provides the GPIO module for LIRC.

%prep
%if %snapshot
%setup -q -n %{name}
#rm -r CVS */CVS */*/CVS
%else
%setup -q
%endif
%patch0 -p1 -b .include
%patch1 -p1 -b .validate
%patch2 -p1 -b .new
%patch3 -p1 -b .dontexit
%patch4 -p0 -b .2.6.27

%build
%if %snapshot
./autogen.sh
%endif

%configure2_5x	--localstatedir=/var \
		--with-x \
		--with-port=0x3f8 \
		--with-irq=4 \
		--disable-manage-devices \
		--with-syslog=LOG_DAEMON \
		--with-driver=userspace \
		--with-transmitter \
		--with-kerneldir=$(pwd) # fixes build as of 20070827

%make \
%if %mdkversion < 1020
DEFS="-DHAVE_CONFIG_H -DHID_MAX_USAGES"
%endif

%if %snapshot
make -C doc release
%endif

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_datadir}/aclocal
mkdir -p %{buildroot}/var/log

%makeinstall_std

install contrib/*.m4 %{buildroot}%{_datadir}/aclocal

mkdir -p %{buildroot}%{_sysconfdir}/udev/rules.d/
install -m644 contrib/lirc.rules %{buildroot}%{_sysconfdir}/udev/rules.d/

install -m644 %{SOURCE2} -D %{buildroot}%{_sysconfdir}/sysconfig/lircd
install -m755 %{SOURCE3} -D %{buildroot}%{_initrddir}/lircd
install -m755 %{SOURCE4} -D %{buildroot}%{_initrddir}/lircmd

cat > %{buildroot}%{_sysconfdir}/lircd.conf<<END
#
# This is a placeholder for your configuration file.
# See %{_datadir}/%{name}-remotes for some examples.
# You might need to install %{name}-remotes package.
#
END

cp -f %{buildroot}%{_sysconfdir}/lirc{,m}d.conf

# dkms

for lircsrcdir in %{name} %{name}-parallel %{name}-gpio; do

install -d -m755 %{buildroot}/usr/src/$lircsrcdir-%{version}-%{release}
cp -a Makefile Makefile.in Makefile.am acinclude.m4 \
	configure.ac config.status config.h \
	%{buildroot}/usr/src/$lircsrcdir-%{version}-%{release}

# Makefiles call there to unnecessarily regenerate files
echo '#!/bin/true' > %{buildroot}/usr/src/$lircsrcdir-%{version}-%{release}/configure
chmod +x %{buildroot}/usr/src/$lircsrcdir-%{version}-%{release}/configure

done

cp -a drivers %{buildroot}/usr/src/%{name}-%{version}-%{release}

for drivername in parallel gpio; do
install -d -m755 %{buildroot}/usr/src/%{name}-$drivername-%{version}-%{release}/drivers
mv %{buildroot}/usr/src/%{name}-%{version}-%{release}/drivers/lirc_$drivername \
	%{buildroot}/usr/src/%{name}-$drivername-%{version}-%{release}/drivers/
cp -a drivers/*.h drivers/Makefile* drivers/lirc_dev \
	%{buildroot}/usr/src/%{name}-$drivername-%{version}-%{release}/drivers/

done

# get modulelist
pushd drivers
drivers=$(echo lirc_* | sed "s/lirc_aver //" | sed "s/lirc_fly98 //" | sed "s/lirc_haup //" | sed "s/lirc_parallel //" | sed "s/lirc_pixview //" | sed "s/lirc_gpio //" | sed "s/lirc_usb//")
popd

cat > %{buildroot}/usr/src/%{name}-%{version}-%{release}/dkms.conf <<EOF
PACKAGE_NAME="%{name}"
PACKAGE_VERSION="%{version}-%{release}"
MAKE[0]="droot=\\\$(pwd); for driver in $drivers; do cd \\\$droot/drivers/\\\$driver; make \
	KERNEL_LOCATION=\$kernel_source_dir AUTOMAKE=true AUTOCONF=true ACLOCAL=true; done"
CLEAN="droot=\\\$(pwd); for driver in $drivers; do cd \\\$droot/drivers/\\\$driver; make \
	clean AUTOMAKE=true AUTOCONF=true ACLOCAL=true; done"
AUTOINSTALL=yes
EOF

i=0
for module in $drivers; do
	cat >> %{buildroot}/usr/src/%{name}-%{version}-%{release}/dkms.conf <<-EOF
	BUILT_MODULE_NAME[$i]="$module"
	BUILT_MODULE_LOCATION[$i]="drivers/$module"
	DEST_MODULE_LOCATION[$i]="/kernel/drivers/input/misc"
	EOF
	i=$((i+1))
done

cat >> %{buildroot}/usr/src/%{name}-%{version}-%{release}/dkms.conf <<-EOF
BUILT_MODULE_NAME[$i]="commandir"
BUILT_MODULE_LOCATION[$i]="drivers/lirc_cmdir"
DEST_MODULE_LOCATION[$i]="/kernel/drivers/input/misc"
EOF
i=$((i+1))

for drivername in parallel gpio; do
cat > %{buildroot}/usr/src/%{name}-$drivername-%{version}-%{release}/dkms.conf <<EOF
PACKAGE_NAME="%{name}-$drivername"
PACKAGE_VERSION="%{version}-%{release}"
MAKE[0]="cd drivers/lirc_$drivername; make \
	KERNEL_LOCATION=\$kernel_source_dir AUTOMAKE=true AUTOCONF=true ACLOCAL=true"
CLEAN="cd drivers/lirc_$drivername; make \
	clean AUTOMAKE=true AUTOCONF=true ACLOCAL=true"
AUTOINSTALL=yes
BUILT_MODULE_NAME[0]="lirc_$drivername"
BUILT_MODULE_LOCATION[0]="drivers/lirc_$drivername"
DEST_MODULE_LOCATION[0]="/kernel/drivers/input/misc"
EOF

done

rm -rf %{buildroot}/dev

%clean
rm -rf %{buildroot}

%if %mdkversion < 200900
%post	-n %{libname} -p /sbin/ldconfig
%endif
%if %mdkversion < 200900
%postun	-n %{libname} -p /sbin/ldconfig
%endif

%post
%create_ghostfile /var/log/lircd root root 644
%_post_service lircd
%_post_service lircmd

%preun
%_preun_service lircmd
%_preun_service lircd

%post -n dkms-%{name}
dkms add     -m %{name} -v %{version}-%{release} --rpm_safe_upgrade &&
dkms build   -m %{name} -v %{version}-%{release} --rpm_safe_upgrade &&
dkms install -m %{name} -v %{version}-%{release} --rpm_safe_upgrade --force
true

%preun -n dkms-%{name}
dkms remove  -m %{name} -v %{version}-%{release} --rpm_safe_upgrade --all
true

%post -n dkms-%{name}-parallel
dkms add     -m %{name}-parallel -v %{version}-%{release} --rpm_safe_upgrade &&
dkms build   -m %{name}-parallel -v %{version}-%{release} --rpm_safe_upgrade &&
dkms install -m %{name}-parallel -v %{version}-%{release} --rpm_safe_upgrade --force
true

%preun -n dkms-%{name}-parallel
dkms remove  -m %{name}-parallel -v %{version}-%{release} --rpm_safe_upgrade --all
true

%post -n dkms-%{name}-gpio
dkms add     -m %{name}-gpio -v %{version}-%{release} --rpm_safe_upgrade &&
dkms build   -m %{name}-gpio -v %{version}-%{release} --rpm_safe_upgrade &&
dkms install -m %{name}-gpio -v %{version}-%{release} --rpm_safe_upgrade --force
true

%preun -n dkms-%{name}-gpio
dkms remove  -m %{name}-gpio -v %{version}-%{release} --rpm_safe_upgrade --all
true

%files
%defattr(-,root,root)
%doc ANNOUNCE AUTHORS NEWS README TODO ChangeLog 
%doc contrib/{irman2lirc,lircs} doc/irxevent.keys
%doc doc/lirc.css doc/html doc/images
%{_initrddir}/*
%config(noreplace) %{_sysconfdir}/sysconfig/*
%config(noreplace) %{_sysconfdir}/*.conf
%config(noreplace) %{_sysconfdir}/udev/rules.d/*.rules
%{_bindir}/*
%{_sbindir}/*
%{_mandir}/*/*

%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/*.so.%{major}*

%files -n %{develname}
%defattr(-,root,root)
%{_includedir}/lirc
%{_datadir}/aclocal/*
%{_libdir}/*.so
%{_libdir}/*.la
%{_libdir}/*.a

%files -n dkms-%{name}
%defattr(-,root,root)
/usr/src/%{name}-%{version}-%{release}

%files -n dkms-%{name}-parallel
%defattr(-,root,root)
/usr/src/%{name}-parallel-%{version}-%{release}

%files -n dkms-%{name}-gpio
%defattr(-,root,root)
/usr/src/%{name}-gpio-%{version}-%{release}


%changelog
* Thu Sep 11 2008 Frederic Crozat <fcrozat@mandriva.com> 0.8.3-4mdv2009.0
+ Revision: 283929
- Change default configuration so lircd is started even if not configured (Fedora), needed for gnome-lirc-properties

* Mon Sep 08 2008 Pascal Terjan <pterjan@mandriva.org> 0.8.3-3mdv2009.0
+ Revision: 282551
- Add upstream patches to build on 2.6.27

* Sun Aug 24 2008 Frederic Crozat <fcrozat@mandriva.com> 0.8.3-2mdv2009.0
+ Revision: 275459
- Patch3 (CVS): don't exit daemon even though device cannot be initialized

* Sun Aug 24 2008 Frederic Crozat <fcrozat@mandriva.com> 0.8.3-1mdv2009.0
+ Revision: 275440
- Release 0.8.3 final
- add patches from Fedora for gnome-lirc-properties support (thanks to Bastien Nocerra) :
 - Patch0 (Fedora): add include directive support for config file
 - Patch1 (upstream): validate transmit buffer
 - Patch2 (Fedora): use new instead of conf as filename suffix in template mode

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Sat May 03 2008 Adam Williamson <awilliamson@mandriva.com> 0.8.3-0.20080501.2mdv2009.0
+ Revision: 200580
- make sure commandir module gets built and installed

* Thu May 01 2008 Adam Williamson <awilliamson@mandriva.com> 0.8.3-0.20080501.1mdv2009.0
+ Revision: 199889
- some spec cleaning
- new snapshot

  + Anssi Hannula <anssi@mandriva.org>
    - fix dkms-lirc-gpio description

* Tue Mar 11 2008 Adam Williamson <awilliamson@mandriva.com> 0.8.2-1.20080310.2mdv2008.1
+ Revision: 184862
- correct the initscript fix (thanks anssi)

* Tue Mar 11 2008 Adam Williamson <awilliamson@mandriva.com> 0.8.2-1.20080310.1mdv2008.1
+ Revision: 184762
- remove /dev in %%install as it's screwing up fix_eol script
- initscript should only start after dkms-lirc so the module actually exists
- new snapshot

* Mon Jan 28 2008 Adam Williamson <awilliamson@mandriva.com> 0.8.2-1.20080128.1mdv2008.1
+ Revision: 159264
- new snapshot (hopefully works better with 2.6.24 final)

* Sat Jan 05 2008 Olivier Blin <oblin@mandriva.com> 0.8.2-1.20080105.1mdv2008.1
+ Revision: 145803
- update to cvs snapshot 20080105 (to fix build with 2.6.24-rc6)
- restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request
    - buildrequires X11-devel instead of XFree86-devel

* Mon Dec 03 2007 Adam Williamson <awilliamson@mandriva.com> 0.8.2-1.20071203.1mdv2008.1
+ Revision: 114643
- new snapshot 20071203 (see if it works with 2.6.24, current doesn't)

* Thu Oct 11 2007 Adam Williamson <awilliamson@mandriva.com> 0.8.2-1.20071011.1mdv2008.1
+ Revision: 97178
- update buildrequires
- new devel policy
- new license policy
- new snapshot (works with 2.6.23 kernels)

* Tue Oct 02 2007 Olivier Blin <oblin@mandriva.com> 0.8.2-1.20070827.3mdv2008.0
+ Revision: 94683
- rebuild

* Tue Oct 02 2007 Olivier Blin <oblin@mandriva.com> 0.8.2-1.20070827.2mdv2008.0
+ Revision: 94681
- rebuild

* Tue Aug 28 2007 Anssi Hannula <anssi@mandriva.org> 0.8.2-1.20070827.1mdv2008.0
+ Revision: 72759
- cvs snapshot (support for recent kernels)
- use dummy --with-kerneldir to fix build
- adapt dkms package for changes in makefiles
- do not run subsequent dkms commands if one fails

* Sun Jun 10 2007 Funda Wang <fundawang@mandriva.org> 0.8.2-1mdv2008.0
+ Revision: 37830
- New version

* Fri Apr 20 2007 Anssi Hannula <anssi@mandriva.org> 0.8.1-1mdv
+ Revision: 16385
- 0.8.1 final
- drop patch1 (now unneeded), patch2 (fixed upstream)


* Thu Mar 15 2007 Anssi Hannula <anssi@mandriva.org> 0.8.1-0.20061104.3mdv2007.1
+ Revision: 144511
- move lirc_gpio to dkms-lirc-gpio (#29304)
- use portaudio0
- force zero exit status for post/preun

* Mon Jan 01 2007 Anssi Hannula <anssi@mandriva.org> 0.8.1-0.20061104.2mdv2007.1
+ Revision: 103006
- patch2: fix repeat flag in dev/input driver (from cvs)
- switch service remove order on uninstallation

* Sat Nov 04 2006 Anssi Hannula <anssi@mandriva.org> 0.8.1-0.20061104.1mdv2007.1
+ Revision: 76624
- new snapshot (support for recent kernels)
- drop patch0, patch2, applied upstream
- disable portaudio support on cooker
- move non-smp parallel dkms module to dkms-lirc-parallel (#26764)
- Import lirc

* Sat Sep 23 2006 Olivier Blin <blino@mandriva.com> 0.8.1-0.20060722.4mdv2007.0
- Patch2: fix udev rule (from CVS, #25989)

* Mon Sep 04 2006 Anssi Hannula <anssi@mandriva.org> 0.8.1-0.20060722.3mdv2007.0
- fix dkms build

* Sun Aug 13 2006 Christiaan Welvaart <cjw@daneel.dyndns.org> 0.8.1-0.20060722.2
- patch1: when checking for libtoolize, do not try to run libtool

* Sun Jul 23 2006 Anssi Hannula <anssi@mandriva.org> 0.8.1-0.20060722.1mdv2007.0
- cvs snapshot (support for recent kernels)
- drop patch1, no longer necessary
- parallelize initscripts
- disable non-working parallel build

* Fri Jan 27 2006 Anssi Hannula <anssi@mandriva.org> 0.8.0-2mdk
- fix buildrequires
- dkms package

* Wed Jan 25 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.8.0-1mdk
- 0.8.0

* Tue Sep 06 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.7.1-5mdk
- libtool 1.4 fixes
- revert previous changes

* Sun Aug 28 2005 Erwan Velu <velu@seanodes.com> 0.7.1-4mdk
- Adding missing requires

* Tue Aug 09 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.7.1-3mdk
- ship with udev rules so that lircmd can work on udev enabled systems

* Tue May 24 2005 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.7.1-2mdk
- --with-transmitter (from gerard quequet, fixes #14933)
- fix build on older releases

* Tue May 17 2005 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.7.1-1mdk
- 0.7.1
- fix executable-marked-as-config-file
- fix no-chkconfig-line
- drop P1 & P3
- cosmetics

* Tue Apr 19 2005 Arnaud de Lorbeau <devel@mandriva.com> 0.7.0-1mdk
- Update 0.7.0
- TODO: Fix autoconf problem

* Wed Aug 04 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.6.6-7mdk
- Add setserial requires (Anthill bug #1017)

